package com.tinysine.tosrwifi;

import java.text.NumberFormat;
import java.util.ArrayList;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.NotificationManager;
import android.app.ProgressDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.InputFilter;
import android.text.InputType;
import android.text.TextUtils;
import android.text.method.PasswordTransformationMethod;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.tinysine.tosrwifi.io.Util;
import com.tinysine.tosrwifi.service.SocketService;

public class Bluemd extends Activity implements OnCheckedChangeListener,
		OnTouchListener {

	private SocketService mSocketService;
	private Button[] relays;
	private boolean[] touchflag;
	private TextView tv_temp;
	private CheckBox cb_mode;

	private boolean isCtemp = true;
	private SharedPreferences sp;
	private ProgressDialog pDialog;
	private boolean isVerify = false;
	private TextView tv_status;

	private ProgressDialog pg;
	private StringBuffer str = new StringBuffer();

	private boolean[] RelayBools = new boolean[8];
	private SharedPreferences preferences;
	private ArrayList<String> devices = new ArrayList<String>();
	public static final String PREFS_NAME = "MyPrefsFile";
	private ProgressDialog progressDialog;

	private boolean isSettingMode = false;
	private String name;
	private int status = Util.BT_DATA_PASSWORD;
	private Button btn_allon;
	private Button btn_alloff;
	
	private static boolean modeflg = true;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.ac_main);
		sp = getSharedPreferences("name", MODE_PRIVATE);
		preferences = getSharedPreferences(PREFS_NAME, 0);
		tv_status = (TextView) findViewById(R.id.tv_stutas);
		pg = new ProgressDialog(this);
		pg.setMessage(this.getResources().getString(R.string.loading));
		pg.setCancelable(true);
		pDialog = new ProgressDialog(this);
		pDialog.setMessage("Verifying...");
		pDialog.setCancelable(false);
		mSocketService = new SocketService(mHandler, this);

		relays = new Button[8];
		relays[0] = (Button) findViewById(R.id.relay1);
		relays[1] = (Button) findViewById(R.id.relay2);
		relays[2] = (Button) findViewById(R.id.relay3);
		relays[3] = (Button) findViewById(R.id.relay4);
		relays[4] = (Button) findViewById(R.id.relay5);
		relays[5] = (Button) findViewById(R.id.relay6);
		relays[6] = (Button) findViewById(R.id.relay7);
		relays[7] = (Button) findViewById(R.id.relay8);
		touchflag = new boolean[8];
		for (int i = 0; i < 8; i++) {
			touchflag[i] = true;
			relays[i].setOnTouchListener(this);
		}

		tv_temp = (TextView) findViewById(R.id.temp);
		registerReceiver(mHomeKeyEventReceiver, new IntentFilter(
				Intent.ACTION_CLOSE_SYSTEM_DIALOGS));
		cb_mode = (CheckBox) findViewById(R.id.cb_mode);
		cb_mode.setOnCheckedChangeListener(this);
		btn_allon = (Button) findViewById(R.id.btn_allon);
		btn_alloff = (Button) findViewById(R.id.btn_alloff);
		isVerify = false;

		if (!ToolHelper.netIsAvail(this)) {
			ToolHelper.setNetworkMethod(this);
		}
	}

	@Override
	public synchronized void onResume() {
		super.onResume();
		for (int index = 0; index < 8; index++) {
			relays[index].setText(sp.getString("name" + index, "Relay"
					+ (index + 1)));
		}
	}

	private static final int REQUEST_LIST_CONNECT_DEVICE = 3;

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.option_menu, menu);
		return true;
	}

	private static final int REQUEST_CONNECT_DEVICE = 1;

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.connect: {
			Intent serverIntent = new Intent(this, ListIPPorts.class);
			startActivityForResult(serverIntent, REQUEST_LIST_CONNECT_DEVICE);
		}
			return true;
		case R.id.preferences: {
			android.os.Process.killProcess(android.os.Process.myPid());
			Bluemd.this.finish();

		}
			return true;
		case R.id.configure: {
			tv_status.setText(R.string.title_not_connected);    ////////////////////
			String c = Bluemd.this.getResources().getString(    ////////////////////
					R.string.title_not_connected);              ///////修改1////////
			str.append(c + "\n");                               ////////////////////
			connectFLg = 0;                                     ////////////////////
			mSocketService.disConnect();                        ////////////////////
			
			if (!ToolHelper.netIsAvail(this)) {
				ToolHelper.setNetworkMethod(this);
				return true;
			}
			progressDialog = ProgressDialog.show(this, "Waiting...",
					"Connecting Server...", true, true);
			liveSetting(SettingConfig.address, SettingConfig.port);
			isSettingMode = true;
			if (sendModeThread != null)
				sendModeThread.Stop();
			if (sendRelayThread != null) {
				sendRelayThread.Stop();
			}
			return true;
		}
		case R.id.setting: {
			Intent intent = new Intent(this, SettingActivity.class);
			startActivity(intent);
			return true;
		}
		}
		return false;
	}

	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		switch (requestCode) {
		case REQUEST_CONNECT_DEVICE:
			if (resultCode == Activity.RESULT_OK) {
				devices.clear();
				String deviceString = preferences.getString("devices", "");
				String[] tmpaaa = null;
				if (deviceString != null && deviceString.length() > 0
						&& !deviceString.equals("")) {
					tmpaaa = deviceString.split(",");
					for (String tmpString : tmpaaa)
						devices.add(tmpString);
				}
				String ip = data.getExtras().getString("ip");
				int port = data.getExtras().getInt("port");
				String name = data.getExtras().getString("name");
				this.address = ip;
				this.port = port;
				this.name = name;
				devices.add(name + " " + ip + ":" + port);
				StringBuilder sb = new StringBuilder();
				for (String tmp : devices) {
					sb.append(tmp);
					sb.append(",");
				}
				String resString = sb.toString().substring(0,
						sb.toString().length());
				Editor editor = preferences.edit();
				editor.putString("devices", resString);
				editor.commit();
				live(name, address, port);
			}
			break;
		case REQUEST_LIST_CONNECT_DEVICE:
			if (resultCode == Activity.RESULT_OK) {
				String ip = data.getExtras().getString("ip");
				int port = data.getExtras().getInt("port");
				this.address = ip;
				this.port = port;
				String name = data.getExtras().getString("name");
				this.name = name;
				SharedPreferences userInfo = getSharedPreferences("user_info",
						0);
				Editor editor = userInfo.edit();
				editor.putString("ip", ip);
				editor.putString("name", name);
				editor.putInt("port", port);
				editor.commit();
				live(name, address, port);
			}
			break;
		}
	}

	private int connectFLg = 0;

	private void setRelayStatus(int value) {
		String result = bytesToHexToTwoString((byte) value);
		int length = result.length();
		result = reverseSort(result);
		for (int i = 0; i < length; i++) {
			if ("1".equals(result.substring(i, i + 1))) {
				RelayBools[i] = true;
			} else {
				RelayBools[i] = false;
			}
		}
		for (int j = length; j < 8; j++) {
			RelayBools[j] = false;
		}
		if (RelayBools[0]) {
			relays[0].setBackgroundResource(R.drawable.btn_left_pressed);
		} else {
			relays[0].setBackgroundResource(R.drawable.btn_left_normal);
		}
		if (RelayBools[1]) {
			relays[1].setBackgroundResource(R.drawable.btn_middle_pressed);
		} else {
			relays[1].setBackgroundResource(R.drawable.btn_middle_normal);
		}
		if (RelayBools[2]) {
			relays[2].setBackgroundResource(R.drawable.btn_middle_pressed);
		} else {
			relays[2].setBackgroundResource(R.drawable.btn_middle_normal);
		}
		if (RelayBools[3]) {
			relays[3].setBackgroundResource(R.drawable.btn_right_pressed);
		} else {
			relays[3].setBackgroundResource(R.drawable.btn_right_nromal);
		}
		if (RelayBools[4]) {
			relays[4].setBackgroundResource(R.drawable.btn_left_pressed);
		} else {
			relays[4].setBackgroundResource(R.drawable.btn_left_normal);
		}
		if (RelayBools[5]) {
			relays[5].setBackgroundResource(R.drawable.btn_middle_pressed);
		} else {
			relays[5].setBackgroundResource(R.drawable.btn_middle_normal);
		}
		if (RelayBools[6]) {
			relays[6].setBackgroundResource(R.drawable.btn_middle_pressed);
		} else {
			relays[6].setBackgroundResource(R.drawable.btn_middle_normal);
		}
		if (RelayBools[7]) {
			relays[7].setBackgroundResource(R.drawable.btn_right_pressed);
		} else {
			relays[7].setBackgroundResource(R.drawable.btn_right_nromal);
		}
	}

	private synchronized String bytesToHexToTwoString(Byte buff) {
		StringBuilder stringBuilder = new StringBuilder("");
		if (buff == null) {
			return null;
		}
		int v = buff & (byte) 0xFF;
		String hv = Integer.toHexString(v);
		if (hv.length() < 2) {
			stringBuilder.append(0);
		}
		stringBuilder.append(hv);
		hv = null;
		System.gc();
		int c = Integer.parseInt(stringBuilder.toString(), 16);
		stringBuilder = null;
		return Integer.toBinaryString(c);
	}

	private String address;
	private int port;

	private void liveData(byte data) {
		if (!mSocketService.isConnected()) {
			connectFLg = 0;
			isVerify = false;
			status = Util.BT_DATA_PASSWORD;
			if (sendModeThread != null) {
				sendModeThread.Stop();
			}
			if (sendRelayThread != null) {
				sendRelayThread.Stop();
			}
			live(address, port);
		} else {
			mSocketService.sendByte(data);
		}
	}

	private void liveData(byte[] data) {
		if (!mSocketService.isConnected()) {
			connectFLg = 0;
			isVerify = false;
			status = Util.BT_DATA_PASSWORD;
			if (sendModeThread != null) {
				sendModeThread.Stop();
			}
			if (sendRelayThread != null) {
				sendRelayThread.Stop();
			}
			live(address, port);
		} else {
			mSocketService.sendBytes(data);
		}
	}

	private void liveSetting(String address, int port) {
		Log.e("tag", "===1==");
		if (!mSocketService.isConnected()) {
			mSocketService.connectService(address, port);
		} else if (mSocketService.isConnected()) {
			try {
				Log.e("tag", "===3==");
				mSocketService.disConnect();
				mSocketService.connectService(address, port);
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
	}

	private void live(String name, String address, int port) {
		if (address == null || "".equals(address)) {
			SharedPreferences userInfo = getSharedPreferences("user_info", 0);
			address = userInfo.getString("ip", "192.168.1.2");
			port = userInfo.getInt("port", 2000);
			name = userInfo.getString("name", "name");
			final String a = address;
			final int b = port;
			AlertDialog.Builder builder = new AlertDialog.Builder(this);
			builder.setMessage(
					"Name:" + name + "\n" + "IP=" + address + "\n" + "Port="
							+ port)
					.setIcon(android.R.drawable.ic_dialog_info)
					.setTitle(R.string.app_name)
					.setCancelable(true)
					.setPositiveButton("Connect",
							new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog,
										int id) {
									if (mSocketService.isConnected()) {
										try {
											mSocketService.disConnect();
											// isConnected = false;
										} catch (Exception ex) {
											ex.printStackTrace();
										}
									}
									if (pg != null && !pg.isShowing()) {
										pg.show();
									}
									mSocketService.connectService(a, b);
								}
							})
					.setNegativeButton("Edit",
							new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog,
										int id) {
									Intent serverIntent = new Intent(
											Bluemd.this, SetIPAndPort.class);
									startActivityForResult(serverIntent,
											REQUEST_CONNECT_DEVICE);
									return;
								}
							});
			AlertDialog alert = builder.create();
			alert.show();
		} else if (!mSocketService.isConnected()) {
			// TODO Auto-generated method stub
			if (pg != null && !pg.isShowing()) {
				pg.show();
			}
			mSocketService.connectService(address, port);
		} else if (mSocketService.isConnected()) {
			try {
				mSocketService.disConnect();
				if (pg != null && !pg.isShowing()) {
					pg.show();
				}
				mSocketService.connectService(address, port);
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
	}

	private void live(String address, int port) {
		if (address == null || "".equals(address)) {
			SharedPreferences userInfo = getSharedPreferences("user_info", 0);
			address = userInfo.getString("ip", "192.168.1.2");
			port = userInfo.getInt("port", 2000);
			String name = userInfo.getString("name", "device");
			final String a = address;
			final int b = port;
			this.name = name;
			AlertDialog.Builder builder = new AlertDialog.Builder(this);
			builder.setMessage(
					"Name=" + name + "\nIP=" + address + "\n" + "Port=" + port)
					.setIcon(android.R.drawable.ic_dialog_info)
					.setTitle(R.string.app_name)
					.setCancelable(true)
					.setPositiveButton(R.string.connect_,
							new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog,
										int id) {
									if (pg != null && !pg.isShowing()) {
										pg.show();
									}
									mSocketService.connectService(a, b);
								}
							})
					.setNegativeButton(R.string.edit,
							new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog,
										int id) {
									Intent serverIntent = new Intent(
											Bluemd.this, SetIPAndPort.class);
									startActivityForResult(serverIntent,
											REQUEST_CONNECT_DEVICE);
									return;
								}
							});
			AlertDialog alert = builder.create();
			alert.show();
		} else if (!mSocketService.isConnected()) {
			// TODO Auto-generated method stub
			if (pg != null && !pg.isShowing()) {
				pg.show();
			}
			mSocketService.connectService(address, port);
		}
	}

	public void cancel() {
		mSocketService.disConnect();
		unregisterReceiver(mHomeKeyEventReceiver);
	}

	private static String reverseSort(String str) {
		String str2 = "";
		for (int i = str.length() - 1; i > -1; i--) {
			str2 += String.valueOf(str.charAt(i));
		}
		return str2;
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		// TODO Auto-generated method stub
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			AlertDialog.Builder builder = new AlertDialog.Builder(this);
			builder.setMessage("Do you exit program?")
					.setIcon(android.R.drawable.ic_dialog_info)
					.setTitle(R.string.app_name)
					.setCancelable(false)
					.setPositiveButton("Yes",
							new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog,
										int id) {
									// cancel();
									NotificationManager noManager = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
									noManager.cancelAll();
									Bluemd.this.finish();
									android.os.Process
											.killProcess(android.os.Process
													.myPid());

								}
							})
					.setNegativeButton("No",
							new DialogInterface.OnClickListener() {

								@Override
								public void onClick(DialogInterface dialog,
										int which) {
									// TODO Auto-generated method stub
								}
							});
			AlertDialog alert = builder.create();
			alert.show();
			return true;
		}
		return super.onKeyDown(keyCode, event);
	}

	public void allOn(View view) {
		// if (connectFLg == 1 && !isVerify) {
		// popEditPassword();
		// return;
		// }
		liveData((byte) 0x64);
	}

	public void onTempSwitch(View v) {
		isCtemp = !isCtemp;
	}

	public void allOff(View view) {
		if (connectFLg == 1 && !isVerify) {
			popEditPassword();
			return;
		}
		liveData((byte) 0x6E);
	}

	@Override
	public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
		// TODO Auto-generated method stub
		if (connectFLg == 1 && !isVerify) {
			popEditPassword();
		}
		if (arg1) {
			btn_alloff.setEnabled(true);
			btn_allon.setEnabled(true);
			liveData((byte) 0x41);
		} else {
			btn_alloff.setEnabled(false);
			btn_allon.setEnabled(false);
			liveData((byte) 0x42);
		}

	}

	private BroadcastReceiver mHomeKeyEventReceiver = new BroadcastReceiver() {
		String SYSTEM_REASON = "reason";
		String SYSTEM_HOME_KEY = "homekey";

		@Override
		public void onReceive(Context context, Intent intent) {
			String action = intent.getAction();
			if (action.equals(Intent.ACTION_CLOSE_SYSTEM_DIALOGS)) {
				String reason = intent.getStringExtra(SYSTEM_REASON);
				if (TextUtils.equals(reason, SYSTEM_HOME_KEY)) {
					tv_status.setText(R.string.title_not_connected);    ////////////////////
					String c = Bluemd.this.getResources().getString(    ////////////////////
							R.string.title_not_connected);              ///////修改3////////
					str.append(c + "\n");                               ////////////////////
					connectFLg = 0;                                     ////////////////////
					disconnect();					
				}
			}
		}
	};

	private void popEditPassword() {
		final EditText eText = new EditText(this);
		InputFilter[] filters = { new InputFilter.LengthFilter(6) };
		eText.setFilters(filters);
		eText.setInputType(InputType.TYPE_CLASS_NUMBER);
		eText.setTransformationMethod(PasswordTransformationMethod.getInstance());
		new AlertDialog.Builder(this).setTitle("Please input the password!")
				.setIcon(android.R.drawable.ic_dialog_info).setView(eText)
				.setCancelable(false)
				.setPositiveButton("OK", new OnClickListener() {

					@Override
					public void onClick(DialogInterface arg0, int arg1) {
						// TODO Auto-generated method stub
						String pa = eText.getText().toString();
						if (!pa.equals("") && pa.length() == 6) {
							pDialog.show();
							sendPassword("3F" + int2Byte(pa));
						} else {
							Toast.makeText(Bluemd.this, "Password is 6 digits!",
									Toast.LENGTH_SHORT).show();
							popEditPassword();
						}
					}
				}).setNegativeButton("Quit", new OnClickListener() {

					@Override
					public void onClick(DialogInterface arg0, int arg1) {
						// TODO Auto-generated method stub
						System.exit(0);
					}
				}).create().show();
	}

	private String int2Byte(String value) {
		int va = Integer.parseInt(value);
		String hex = Integer.toHexString(va);
		int len = hex.length();
		String data = "000000";
		data = data.substring(0, 6 - len) + hex;
		String result = data.substring(4, 6) + data.substring(2, 4)
				+ data.substring(0, 2);
		return result;
	}

	@Override
	public boolean onTouch(View arg0, MotionEvent arg1) {
		// TODO Auto-generated method stub
		switch (arg0.getId()) {
		case R.id.relay1: {
			switch (arg1.getAction()) {
			case MotionEvent.ACTION_DOWN: {
				if (connectFLg == 1 && !isVerify) {
					popEditPassword();
				}
				if (cb_mode.isChecked()) {
					modeflg = true;   
					if (RelayBools[0]) {
						liveData((byte) 0x6F);
					} else {
						liveData((byte) 0x65);
					}
				} else {
					liveData((byte) 0x00);
					if (mSocketService.isConnected()) {
						touchflag[0] = true;
						modeflg = false;  
						new Thread(new Runnable() {

							@Override
							public void run() {
								// TODO Auto-generated method stub
								while (touchflag[0]) {
									try {
										Thread.sleep(250);
										if (touchflag[0]) {
											liveData((byte) 0x65);
											try {
												Thread.sleep(300);
											} catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
										}
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						}).start();
						relays[0]
								.setBackgroundResource(R.drawable.btn_left_pressed);
					}
				}
			}
				break;
			case MotionEvent.ACTION_UP: {
				if (!cb_mode.isChecked() && mSocketService.isConnected()) {
					touchflag[0] = false;
					liveData((byte) 0x6F);
					relays[0]
							.setBackgroundResource(R.drawable.btn_left_normal);   
					modeflg = true; 
				}
			}
				break;
			}
		}
			break;
		case R.id.relay2: {
			switch (arg1.getAction()) {
			case MotionEvent.ACTION_DOWN: {
				if (connectFLg == 1 && !isVerify) {
					popEditPassword();
				}
				if (cb_mode.isChecked()) {
					modeflg = true; 
					if (RelayBools[1]) {
						liveData((byte) 0x70);
					} else {
						liveData((byte) 0x66);
					}
				} else {
					liveData((byte) 0x00);
					if (mSocketService.isConnected()) {
						touchflag[1] = true;
						modeflg = false; 
						new Thread(new Runnable() {

							@Override
							public void run() {
								// TODO Auto-generated method stub
								while (touchflag[1]) {
									try {
										Thread.sleep(250);
										if (touchflag[1]) {
											liveData((byte) 0x66);
											try {
												Thread.sleep(300);
											} catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
										}
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						}).start();
						relays[1]
								.setBackgroundResource(R.drawable.btn_middle_pressed);
					}
				}
			}
				break;
			case MotionEvent.ACTION_UP: {
				if (!cb_mode.isChecked() && mSocketService.isConnected()) {
					touchflag[1] = false;
					liveData((byte) 0x70);
					relays[1]
							.setBackgroundResource(R.drawable.btn_middle_normal);
					modeflg = true;
				}
			}
				break;
			}
		}
			break;
		case R.id.relay3: {
			switch (arg1.getAction()) {
			case MotionEvent.ACTION_DOWN: {
				if (connectFLg == 1 && !isVerify) {
					popEditPassword();
				}
				if (cb_mode.isChecked()) {
					modeflg = true;
					if (RelayBools[2]) {
						liveData((byte) 0x71);
					} else {
						liveData((byte) 0x67);
					}
				} else {
					liveData((byte) 0x00);
					if (mSocketService.isConnected()) {
						touchflag[2] = true;
						modeflg = false; 
						new Thread(new Runnable() {

							@Override
							public void run() {
								// TODO Auto-generated method stub
								while (touchflag[2]) {
									try {
										Thread.sleep(250);
										if (touchflag[2]) {
											liveData((byte) 0x67);
											try {
												Thread.sleep(300);
											} catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
										}
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						}).start();
						relays[2]
								.setBackgroundResource(R.drawable.btn_middle_pressed);
					}
				}
			}
				break;
			case MotionEvent.ACTION_UP: {
				if (!cb_mode.isChecked() && mSocketService.isConnected()) {
					touchflag[2] = false;
					liveData((byte) 0x71);
					relays[2]
							.setBackgroundResource(R.drawable.btn_middle_normal);   
					modeflg = true;  
				}
			}
				break;
			}
		}
			break;
		case R.id.relay4: {
			switch (arg1.getAction()) {
			case MotionEvent.ACTION_DOWN: {
				if (connectFLg == 1 && !isVerify) {
					popEditPassword();
				}
				if (cb_mode.isChecked()) {
					modeflg = true;   
					if (RelayBools[3]) {
						liveData((byte) 0x72);
					} else {
						liveData((byte) 0x68);
					}
				} else {
					liveData((byte) 0x00);
					if (mSocketService.isConnected()) {
						touchflag[3] = true;
						modeflg = false; 
						new Thread(new Runnable() {

							@Override
							public void run() {
								// TODO Auto-generated method stub
								while (touchflag[3]) {
									try {
										Thread.sleep(250);
										if (touchflag[3]) {
											liveData((byte) 0x68);
											try {
												Thread.sleep(300);
											} catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
										}
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						}).start();
						relays[3]
								.setBackgroundResource(R.drawable.btn_right_pressed);
					}
				}
			}
				break;
			case MotionEvent.ACTION_UP: {
				if (!cb_mode.isChecked() && mSocketService.isConnected()) {
					touchflag[3] = false;
					liveData((byte) 0x72);
					relays[3]
							.setBackgroundResource(R.drawable.btn_right_nromal);
					modeflg = true;  
				}
			}
				break;
			}
		}
			break;
		case R.id.relay5: {
			switch (arg1.getAction()) {
			case MotionEvent.ACTION_DOWN: {
				if (connectFLg == 1 && !isVerify) {
					popEditPassword();
				}
				if (cb_mode.isChecked()) {
					modeflg = true; 
					if (RelayBools[4]) {
						liveData((byte) 0x73);
					} else {
						liveData((byte) 0x69);
					}
				} else {
					liveData((byte) 0x00);
					if (mSocketService.isConnected()) {
						touchflag[4] = true;
						modeflg = false;  
						new Thread(new Runnable() {

							@Override
							public void run() {
								// TODO Auto-generated method stub
								while (touchflag[4]) {
									try {
										Thread.sleep(250);
										if (touchflag[4]) {
											liveData((byte) 0x69);
											try {
												Thread.sleep(300);
											} catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
										}
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						}).start();
						relays[4]
								.setBackgroundResource(R.drawable.btn_left_pressed);
					}
				}
			}
				break;
			case MotionEvent.ACTION_UP: {
				if (!cb_mode.isChecked() && mSocketService.isConnected()) {
					touchflag[4] = false;
					liveData((byte) 0x73);
					relays[4]
							.setBackgroundResource(R.drawable.btn_left_normal);
					modeflg = true; 
				}
			}
				break;
			}
		}
			break;
		case R.id.relay6: {
			switch (arg1.getAction()) {
			case MotionEvent.ACTION_DOWN: {
				if (connectFLg == 1 && !isVerify) {
					popEditPassword();
				}
				if (cb_mode.isChecked()) {
					modeflg = true;
					if (RelayBools[5]) {
						liveData((byte) 0x74);
					} else {
						liveData((byte) 0x6A);
					}
				} else {
					liveData((byte) 0x00);
					if (mSocketService.isConnected()) {
						touchflag[5] = true;
						modeflg = false; 
						new Thread(new Runnable() {

							@Override
							public void run() {
								// TODO Auto-generated method stub
								while (touchflag[5]) {
									try {
										Thread.sleep(250);
										if (touchflag[5]) {
											liveData((byte) 0x6A);
											try {
												Thread.sleep(300);
											} catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
										}
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						}).start();
						relays[5]
								.setBackgroundResource(R.drawable.btn_middle_pressed);
					}
				}
			}
				break;
			case MotionEvent.ACTION_UP: {
				if (!cb_mode.isChecked() && mSocketService.isConnected()) {
					touchflag[5] = false;
					liveData((byte) 0x74);
					relays[5]
							.setBackgroundResource(R.drawable.btn_middle_normal);
					modeflg = true;
				}
			}
				break;
			}
		}
			break;
		case R.id.relay7: {
			switch (arg1.getAction()) {
			case MotionEvent.ACTION_DOWN: {
				if (connectFLg == 1 && !isVerify) {
					popEditPassword();
				}
				if (cb_mode.isChecked()) {
					modeflg = true;
					if (RelayBools[6]) {
						liveData((byte) 0x75);
					} else {
						liveData((byte) 0x6B);
					}
				} else {
					liveData((byte) 0x00);
					if (mSocketService.isConnected()) {
						touchflag[6] = true;
						modeflg = false;
						new Thread(new Runnable() {

							@Override
							public void run() {
								// TODO Auto-generated method stub
								while (touchflag[6]) {
									try {
										Thread.sleep(250);
										if (touchflag[6]) {
											liveData((byte) 0x6B);
											try {
												Thread.sleep(300);
											} catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
										}
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						}).start();
						relays[6]
								.setBackgroundResource(R.drawable.btn_middle_pressed);
					}
				}
			}
				break;
			case MotionEvent.ACTION_UP: {
				if (!cb_mode.isChecked() && mSocketService.isConnected()) {
					touchflag[6] = false;
					liveData((byte) 0x75);
					relays[6]
							.setBackgroundResource(R.drawable.btn_middle_normal);
					modeflg = true;
				}
			}
				break;
			}
		}
			break;
		case R.id.relay8: {
			switch (arg1.getAction()) {
			case MotionEvent.ACTION_DOWN: {
				if (connectFLg == 1 && !isVerify) {
					popEditPassword();
				}
				if (cb_mode.isChecked()) {
					modeflg = true;
					if (RelayBools[7]) {
						liveData((byte) 0x76);
					} else {
						liveData((byte) 0x6C);
					}
				} else {
					liveData((byte) 0x00);
					if (mSocketService.isConnected()) {
						touchflag[7] = true;
						modeflg = false;
						new Thread(new Runnable() {

							@Override
							public void run() {
								// TODO Auto-generated method stub
								while (touchflag[7]) {
									try {
										Thread.sleep(250);
										if (touchflag[7]) {
											liveData((byte) 0x6C);
											try {
												Thread.sleep(300);
											} catch (InterruptedException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
										}
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
							}
						}).start();
						relays[7]
								.setBackgroundResource(R.drawable.btn_right_pressed);
					}
				}
			}
				break;
			case MotionEvent.ACTION_UP: {
				if (!cb_mode.isChecked() && mSocketService.isConnected()) {
					touchflag[7] = false;
					liveData((byte) 0x76);
					relays[7]
							.setBackgroundResource(R.drawable.btn_right_nromal);
					modeflg = true;
				}
			}
				break;
			}
		}
			break;
		}
		return false;
	}

	private void sendPassword(String hexString) {
		status = Util.BT_DATA_PASSWORD;
		byte[] datas = hexStringToByte(hexString);
		Log.e("tag", "==>len = " + datas.length);
		for (byte b : datas) {
			Log.e("tag", "===>b = " + b);
		}
		byte[] da = new byte[4];
		da[0] = (byte) 0x3F;
		da[1] = (byte) 0x06;
		da[2] = (byte) 0x12;
		da[3] = (byte) 0x0F;
		for (byte bbb : da) {
			Log.e("tag", "===>b1 = " + bbb);
		}
		liveData(datas);
	}

	private byte[] hexStringToByte(String hex) {
		int len = hex.length() / 2;
		byte[] result = new byte[len];
		for (int i = 0; i < len; i++) {
			result[i] = (byte) Integer.parseInt(
					hex.substring(2 * i, 2 * i + 2), 16);
		}
		return result;
	}

	private SendModeThread sendModeThread = null;

	private void sendMode() {
		status = Util.BT_DATA_MODE;
		sendModeThread = new SendModeThread();
		sendModeThread.start();
	}

	private class SendModeThread extends Thread {
		boolean isFlag = true;

		@Override
		public void run() {
			// TODO Auto-generated method stub
			while (isFlag) {
				liveData((byte) 0x43);
				try {
					sleep(500);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			super.run();
		}

		public void Stop() {
			isFlag = false;
		}
	}

	private SendAndRec sendRelayThread;

	private void sendRelay() {
		status = Util.BT_DATA_RELAY;
		sendRelayThread = new SendAndRec();
		sendRelayThread.start();
	}

	@Override
	public void onDestroy() {
		super.onDestroy();
		cancel();
	}

	private class SendAndRec extends Thread {
		boolean senflg = true;

		@Override
		public void run() {
			// TODO Auto-generated method stub
			super.run();
			while (senflg) {
				if(modeflg){ 
					liveData((byte) 0x44);
					try {
						sleep(300);
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
			}
		}

		public void Stop() {
			senflg = false;
		}
	}

	private Handler mHandler = new Handler(new Handler.Callback() {

		@Override
		public boolean handleMessage(Message msg) {
			// TODO Auto-generated method stub
			switch (msg.what) {
			case Util.WIFI_STATE: {
				switch (msg.arg1) {
				case Util.STATE_CONNECTING: {
					if (isSettingMode) {
						
					} else {
						tv_status.setText(R.string.title_connecting);
						String b = Bluemd.this.getResources().getString(
								R.string.title_connecting);
						str.append(b + "\n");
						connectFLg = 0;
					}
				}
					break;
				case Util.STATE_CONNECTED: {
					if (isSettingMode) {
						if (progressDialog != null) {
							progressDialog.dismiss();
						}
						isSettingMode = false;
						Intent serverIntent = new Intent(Bluemd.this,
								Setting.class);
						startActivityForResult(serverIntent,
								REQUEST_LIST_CONNECT_DEVICE);
						disconnect();
					} else {
						if (pg != null && pg.isShowing()) {
							pg.dismiss();
						}
						tv_status.setText(R.string.title_connected_to);
						if (name != null) {
							tv_status.append(name);
						}
						String a = Bluemd.this.getResources().getString(
								R.string.title_connected_to);
						str.append(a + name + "\n");
						connectFLg = 1;
						if (pDialog != null) {
							pDialog.cancel();
						}
						if (!isVerify) {
							popEditPassword();
						}
					}
				}
					break;
				case Util.STATE_NONE: {
					if (pg != null && pg.isShowing()) {
						pg.dismiss();
					}
					if (isSettingMode) {
						isSettingMode = false;
						progressDialog.dismiss();
						AlertDialog.Builder aBuilder = new AlertDialog.Builder(
								Bluemd.this);
						aBuilder.setTitle("Error");
						aBuilder.setMessage("Connect failed，Please try again!");
						aBuilder.setPositiveButton("OK",
								new AlertDialog.OnClickListener() {
									@Override
									public void onClick(DialogInterface dialog,
											int which) {
										// TODO Auto-generated method stub
										isSettingMode = false;
									}
								});
						aBuilder.create().show();
					} else {
						tv_status.setText(R.string.title_not_connected);
						String c = Bluemd.this.getResources().getString(
								R.string.title_not_connected);
						str.append(c + "\n");
						connectFLg = 0;
					}
				}
					break;
				}
			}
				break;
			case Util.WIFI_DATA: {
				byte[] datas = (byte[]) msg.obj;
				if (datas != null) {
					int arg2 = datas.length;
					Log.e("tag", "===Len = " + arg2 + ",status = " + status);
					if (status == Util.BT_DATA_MODE) {
						if (arg2 == 1) {
							if (datas[0] == 65) {
								cb_mode.setChecked(true);
							} else {
								cb_mode.setChecked(false);
							}
							if (sendModeThread != null
									&& sendModeThread.isAlive()) {
								sendModeThread.Stop();
							}
							sendRelay();
						}
					} else if (status == Util.BT_DATA_RELAY) {
						if (arg2 == 4) {
							setRelayStatus(datas[0]);
							byte msb = datas[2];
							byte lsb = datas[3];
							if (msb == 0 && lsb == 0) {
								tv_temp.setText("NC");
							} else {
								int LSB = lsb < 0 ? lsb + 256 : lsb;
								double te = (msb * 255 + LSB) / 16.0;
								NumberFormat format = NumberFormat
										.getNumberInstance();
								format.setMaximumFractionDigits(2);
								if (isCtemp) {
									tv_temp.setText(format.format(te) + "℃");
								} else {
									double te1 = te * 9 / 5 + 32;
									tv_temp.setText(format.format(te1) + "℉");
								}
							}
						}
					} else if (status == Util.BT_DATA_PASSWORD) {
						if (arg2 == 1) {
							int password = datas[0];
							if (pDialog != null) {
								pDialog.cancel();
							}
							if (password == 1) {
								isVerify = true;
								sendMode();
								Toast.makeText(Bluemd.this, "Verify Successful!",
										Toast.LENGTH_SHORT).show();
							} else {
								Toast.makeText(Bluemd.this,
										"Verify failed, password incorrcet! Please reset your board!",
										Toast.LENGTH_SHORT).show();
								isVerify = false;
								popEditPassword();
							}
						}
					}
				}
			}
			default:
				break;
			}
			return false;
		}
	});


	private void disconnect() {
		isVerify = false;
		connectFLg = 0;
		mSocketService.disConnect();
		if (sendRelayThread != null) {
			sendRelayThread.Stop();
		}
		if (sendModeThread != null) {
			sendModeThread.Stop();
		}
	}
}