package com.tinysine.tosrwifi;

import java.util.ArrayList;
import java.util.HashMap;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView.OnItemLongClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.Toast;

public class ListIPPorts extends Activity implements OnItemClickListener,
		OnItemLongClickListener {

	EditText EditText1;
	EditText EditText2;
	Button buttonOn;

	String ip;
	int port = 80;
	SharedPreferences preferences;
	ArrayList<String> devices = new ArrayList<String>();
	ArrayList<HashMap<String, Object>> listItem = new ArrayList<HashMap<String, Object>>();
	ListView listview;
	SimpleAdapter listItemAdapter;
	private static final int REQUEST_CONNECT_DEVICE = 1234;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_INDETERMINATE_PROGRESS);
		setContentView(R.layout.listips);
		preferences = getSharedPreferences(Bluemd.PREFS_NAME, 0);

		Button addNewButton = (Button) findViewById(R.id.button_scan);
		addNewButton.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				Intent serverIntent = new Intent(getApplicationContext(),
						SetIPAndPort.class);
				startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE);
			}
		});

		String deviceString = preferences.getString("devices", "");
		String[] tmp = null;
		if (deviceString != null && deviceString.length() > 0
				&& !deviceString.equals("")) {
			tmp = deviceString.split(",");
			if (tmp == null) {
				Toast.makeText(this, "There is no device,Add one...",
						Toast.LENGTH_LONG).show();
				// this.finish();
				Intent serverIntent = new Intent(this, SetIPAndPort.class);
				startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE);
				return;
			}
			for (String tmpString : tmp)
				devices.add(tmpString);
		} else {
			Toast.makeText(this, "There is no device,Add one...",
					Toast.LENGTH_LONG).show();
			Intent serverIntent = new Intent(this, SetIPAndPort.class);
			startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE);
			return;
			// this.finish();
		}

		listview = (ListView) findViewById(R.id.listviewIP);

		// 生成动态数组，加入数据

		if (tmp == null || tmp.length <= 0) {
			Toast.makeText(this, "There is no device,Add one...",
					Toast.LENGTH_LONG).show();
			Intent serverIntent = new Intent(this, SetIPAndPort.class);
			startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE);
			return;
		}
		for (String data : tmp) {

			HashMap<String, Object> map = new HashMap<String, Object>();
			map.put("Name", data);
			listItem.add(map);
		}

		listItemAdapter = new SimpleAdapter(this, listItem,
				R.layout.listviewitem, new String[] { "Name" },
				new int[] { R.id.listviewItem });

		listview.setAdapter(listItemAdapter);

		listview.setOnItemClickListener(this);
		listview.setOnItemLongClickListener(this);

	}

	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		switch (requestCode) {

		case REQUEST_CONNECT_DEVICE:

			if (resultCode == Activity.RESULT_OK) {
				String ip = data.getExtras().getString("ip");
				int port = data.getExtras().getInt("port");
				String name = data.getExtras().getString("name");

				devices.add(name + " " + ip + ":" + port);
				StringBuilder sb = new StringBuilder();
				for (String tmp : devices) {
					sb.append(tmp);
					sb.append(",");
				}
				String resString = sb.toString().substring(0,
						sb.toString().length());

				Editor editor = preferences.edit();
				editor.putString("devices", resString);
				editor.commit();

				Intent intent = new Intent();
				intent.putExtra("ip", ip);
				intent.putExtra("port", port);
				intent.putExtra("name", name);
				setResult(Activity.RESULT_OK, intent);
				this.finish();

			}
			break;

		default:
			break;
		}

	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		// TODO Auto-generated method stub
		if (keyCode == KeyEvent.KEYCODE_HOME) {
			this.finish();
			return false;
		}
		return super.onKeyDown(keyCode, event);
	}

	@Override
	public boolean onItemLongClick(AdapterView<?> arg0, View arg1, int arg2,
			long arg3) {
		// TODO Auto-generated method stub
		listItem.remove(arg2);

		if (listItem.size() > 0) {

			StringBuilder sb = new StringBuilder();

			for (HashMap<String, Object> tmp : listItem) {
				sb.append((String) (tmp.get("Name")));
				sb.append(",");
			}
			String resString = sb.toString().substring(0,
					sb.toString().length());

			Editor editor = preferences.edit();
			editor.putString("devices", resString);
			editor.commit();
			if (listItem.size() <= 0) {
				Toast.makeText(this, "There is no device,Add one...",
						Toast.LENGTH_LONG).show();
				this.finish();
				return true;
			}
			listItemAdapter.notifyDataSetChanged();

		} else {

			Editor editor = preferences.edit();
			editor.putString("devices", "");
			editor.commit();

			Toast.makeText(this, "There is no device,Add one...",
					Toast.LENGTH_LONG).show();
			this.finish();
			return true;

		}

		return true;
	}

	@Override
	public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
		// TODO Auto-generated method stub
		String[] dataString = ((String) (listItem.get(arg2).get("Name")))
				.split(":");

		Intent intent = new Intent();
		intent.putExtra("name", dataString[0].split(" ")[0]);
		intent.putExtra("ip", dataString[0].split(" ")[1]);
		intent.putExtra("port", Integer.parseInt(dataString[1]));

		setResult(Activity.RESULT_OK, intent);
		this.finish();

	}

}
