package com.tinysine.tosrwifi;

import java.util.ArrayList;
import java.util.List;

import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentActivity;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentPagerAdapter;
import android.support.v4.view.ViewPager;

public class Setting extends FragmentActivity {

	private List<Fragment> fragmentList = new ArrayList<Fragment>();
	private List<String> titleList = new ArrayList<String>();

	private SettingFragmentStepOne settingFragmentStepOne;
	private SettingFragmentStepTwo settingFragmentStepTwo;
	private SettingFragmentStepThree settingFragmentStepThree;
	private SettingFragmentStepFour settingFragmentStepFour;

	public static final int REQUEST_SETTING_CONFIG = 100;
	private ViewPager vp = null;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.adddevices);
		vp = (ViewPager) findViewById(R.id.addDevicesViewPager);
		settingFragmentStepOne = new SettingFragmentStepOne();
		settingFragmentStepTwo = new SettingFragmentStepTwo();
		settingFragmentStepThree = new SettingFragmentStepThree();
		settingFragmentStepFour = new SettingFragmentStepFour();

		fragmentList.add(settingFragmentStepOne);
		fragmentList.add(settingFragmentStepTwo);
		fragmentList.add(settingFragmentStepThree);
		fragmentList.add(settingFragmentStepFour);

		titleList.add("Step 1");
		titleList.add("Step 2");
		titleList.add("Step 3");
		titleList.add("Step 4");

		settingFragmentStepOne.setOKCallBack(new CallBackInterface() {

			@Override
			public void callBack() {
				// TODO Auto-generated method stub
				vp.setCurrentItem(1, true);
				settingFragmentStepTwo.hideKey();
			}
		});
		settingFragmentStepTwo.setOKCallBack(new CallBackInterface() {

			@Override
			public void callBack() {
				// TODO Auto-generated method stub
				vp.setCurrentItem(2, true);
			}
		});
		settingFragmentStepThree.setOKCallBack(new CallBackInterface() {

			@Override
			public void callBack() {
				// TODO Auto-generated method stub
				vp.setCurrentItem(3, true);
			}
		});
		settingFragmentStepFour.setOKCallBack(new CallBackInterface() {

			@Override
			public void callBack() {
				// TODO Auto-generated method stub
				// vp.setCurrentItem(1,true);
				Intent intent = new Intent(Setting.this, SettingConfig.class);
				intent.putExtra("name",
						settingFragmentStepOne.getEditTextString());
				intent.putExtra("WiFiName",
						settingFragmentStepTwo.getEditTextString());
				intent.putExtra("WiFiPassword",
						settingFragmentStepThree.getEditTextString());
				intent.putExtra("IP",
						settingFragmentStepFour.getEditTextString());
				startActivityForResult(intent, REQUEST_SETTING_CONFIG);
			}
		});

		settingFragmentStepOne.setCancleCallBack(new CallBackInterface() {

			@Override
			public void callBack() {
				// TODO Auto-generated method stub
				// vp.setCurrentItem(1,true);
				Setting.this.finish();
			}
		});
		settingFragmentStepTwo.setCancleCallBack(new CallBackInterface() {

			@Override
			public void callBack() {
				// TODO Auto-generated method stub
				vp.setCurrentItem(0, true);
			}
		});
		settingFragmentStepThree.setCancleCallBack(new CallBackInterface() {

			@Override
			public void callBack() {
				// TODO Auto-generated method stub
				vp.setCurrentItem(1, true);
				settingFragmentStepTwo.hideKey();
			}
		});
		settingFragmentStepFour.setCancleCallBack(new CallBackInterface() {

			@Override
			public void callBack() {
				// TODO Auto-generated method stub
				vp.setCurrentItem(2, true);
			}
		});

		vp.setAdapter(new myPagerAdapter(getSupportFragmentManager(),
				fragmentList, titleList));

	}

	private class myPagerAdapter extends FragmentPagerAdapter {

		private List<Fragment> fragmentList;
		private List<String> titleList;

		public myPagerAdapter(FragmentManager fm, List<Fragment> fragmentList,
				List<String> titleList) {
			super(fm);
			this.fragmentList = fragmentList;
			this.titleList = titleList;
		}

		@Override
		public Fragment getItem(int arg0) {
			return (fragmentList == null || fragmentList.size() == 0) ? null
					: fragmentList.get(arg0);
		}

		@Override
		public CharSequence getPageTitle(int position) {
			return (titleList.size() > position) ? titleList.get(position) : "";
		}

		@Override
		public int getCount() {
			return fragmentList == null ? 0 : fragmentList.size();
		}
	}

	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		switch (requestCode) {
		case REQUEST_SETTING_CONFIG:
			Setting.this.finish();
		}
	}

}
