package com.tinysine.tosrwifi;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;

public class SettingFragmentStepFour extends Fragment implements
		OnClickListener {

	private CallBackInterface callBackOK = null;
	private CallBackInterface callBackCancle = null;
	private EditText editText;

	public SettingFragmentStepFour() {
		super();
	}

	public String getEditTextString() {
		if (editText != null) {
			return editText.getText().toString();
		}
		return null;
	}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		View v = inflater.inflate(R.layout.setting_config4, container, false);
		Button buttonOK = (Button) v.findViewById(R.id.next);
		buttonOK.setOnClickListener(this);

		Button buttonCancle = (Button) v.findViewById(R.id.back);
		buttonCancle.setOnClickListener(this);

		editText = (EditText) v.findViewById(R.id.edittext);
		return v;
	}

	public void setOKCallBack(CallBackInterface callBack) {
		this.callBackOK = callBack;
	}

	public void setCancleCallBack(CallBackInterface callBack) {
		this.callBackCancle = callBack;
	}

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		switch (v.getId()) {
		case R.id.next:
			if (callBackOK != null)
				callBackOK.callBack();
			break;
		case R.id.back:
			if (callBackCancle != null)
				callBackCancle.callBack();
			break;
		default:
			break;
		}
	}

}
