package com.tinysine.tosrwifi;

import java.util.ArrayList;

import android.content.Context;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

public class SettingFragmentStepTwo extends Fragment implements OnClickListener {

	private CallBackInterface callBackOK = null;
	private CallBackInterface callBackCancle = null;
	private EditText editText;
	ArrayList<String> wifiList;
	ListView listView;

	public SettingFragmentStepTwo() {
		super();
	}

	public String getEditTextString() {
		if (editText != null) {
			return editText.getText().toString();
		}
		return null;
	}

	public void hideKey() {
		InputMethodManager imm = (InputMethodManager) getActivity()
				.getSystemService(Context.INPUT_METHOD_SERVICE);
		imm.hideSoftInputFromWindow(editText.getWindowToken(), 0);
	}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		View v = inflater.inflate(R.layout.setting_config2, container, false);
		Button buttonOK = (Button) v.findViewById(R.id.next);
		buttonOK.setOnClickListener(this);

		Button buttonCancle = (Button) v.findViewById(R.id.back);
		buttonCancle.setOnClickListener(this);

		TextView textView = (TextView) v.findViewById(R.id.textview);
		textView.requestFocus();
		editText = (EditText) v.findViewById(R.id.edittext);

		WifiAdmin mWifiAdmin = new WifiAdmin(getActivity());
		wifiList = mWifiAdmin.getScanResultList();

		listView = (ListView) v.findViewById(R.id.myListview);
		listView.setAdapter(new ArrayAdapter<String>(getActivity(),
				android.R.layout.simple_expandable_list_item_1, wifiList));
		listView.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2,
					long arg3) {
				// TODO Auto-generated method stub
				editText.setText(wifiList.get(arg2));
			}
		});

		return v;

	}

	public void setOKCallBack(CallBackInterface callBack) {
		this.callBackOK = callBack;
	}

	public void setCancleCallBack(CallBackInterface callBack) {
		this.callBackCancle = callBack;
	}

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		switch (v.getId()) {
		case R.id.next:
			if (callBackOK != null)
				callBackOK.callBack();
			break;
		case R.id.back:
			if (callBackCancle != null)
				callBackCancle.callBack();
			break;
		default:
			break;
		}
	}

}
