package com.tinysine.tosrwifi;

import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;

public class ToolHelper {

	/*
	 * Set network
	 */
	public static void setNetworkMethod(final Context context) {
		AlertDialog.Builder builder = new Builder(context);
		builder.setIcon(android.R.drawable.ic_dialog_info);
		builder.setTitle("Tip")
				.setMessage(
						"The network connection is not available, setting now?")
				.setPositiveButton("Setting",
						new DialogInterface.OnClickListener() {
							@Override
							public void onClick(DialogInterface dialog,
									int which) {
								// TODO Auto-generated method stub
								Intent intent = null;
								if (android.os.Build.VERSION.SDK_INT > 10) {
									intent = new Intent(
											android.provider.Settings.ACTION_SETTINGS);
								} else {
									intent = new Intent(
											android.provider.Settings.ACTION_WIRELESS_SETTINGS);
								}
								context.startActivity(intent);
							}
						})
				.setNegativeButton("Cancel",
						new DialogInterface.OnClickListener() {
							@Override
							public void onClick(DialogInterface dialog,
									int which) {
								// TODO Auto-generated method stub
								dialog.dismiss();
							}
						}).show();
	}

	public static boolean netIsAvail(Context context) {
		ConnectivityManager manager = (ConnectivityManager) context
				.getSystemService(Context.CONNECTIVITY_SERVICE);
		if (manager == null) {
			return false;
		}
		NetworkInfo networkinfo = manager.getActiveNetworkInfo();
		if (networkinfo == null || !networkinfo.isAvailable()) {
			return false;
		}
		return true;
	}

}
