package com.tinysine.tosrwifi.service;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.Socket;

import android.content.Context;
import android.os.Handler;
import android.os.Message;
import android.util.Log;

import com.tinysine.tosrwifi.io.Util;

public class SocketService {

	private static Socket socket = null;
	private static BufferedInputStream ins;

	private static OutputStream output;
	private Handler mHandler = null;

	public SocketService(Handler aHandler, Context aContext) {
		super();
		mHandler = aHandler;
	}

	public void connectService(final String ip, final int port) {
		new Thread(new Runnable() {
			@Override
			public void run() {
				// TODO Auto-generated method stub
				try {
					mHandler.obtainMessage(Util.WIFI_STATE,
							Util.STATE_CONNECTING, -1).sendToTarget();
					Log.e("tag", "==1===");
					count = 10;
					mHandler.post(runnable);
					Log.e("tag", "==2===");
					socket = new Socket(ip, port);
					output = socket.getOutputStream();
					ins = new BufferedInputStream(socket.getInputStream());
					Log.e("tag", "==3===");
					mHandler.removeCallbacks(runnable);
					mHandler.obtainMessage(Util.WIFI_STATE,
							Util.STATE_CONNECTED, -1).sendToTarget();
					getData();
				} catch (Exception e) {
					// TODO Auto-generated catch block
					Log.e("tag", "===>e = "+e.getMessage());
					mHandler.removeCallbacks(runnable);
					mHandler.obtainMessage(Util.WIFI_STATE, Util.STATE_NONE, -1)
							.sendToTarget();
				}
			}
		}).start();
	}

	private void getData() {
		try {
			while (true) {
				if (socket.isConnected()) {
					if (!socket.isInputShutdown()) {
						int len1 = ins.available();
						if (len1 > 0) {
							byte[] datas = new byte[len1];
							ins.read(datas);
							Message message = mHandler
									.obtainMessage(Util.WIFI_DATA);
							message.obj = datas;
							mHandler.sendMessage(message);
						}
					}
				}
			}
		} catch (Exception e) {
			Log.e("tag", "====>getData ===5===");
			e.printStackTrace();
		}
	}

	public void disConnect() {
		if (output != null) {
			try {
				output.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		if (socket != null && socket.isConnected()) {
			try {
				socket.shutdownInput();
				socket.shutdownOutput();
				socket.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			socket = null;
		}
	}

	public void sendByte(byte data) {
		if (socket != null && socket.isConnected()) {
			if (output != null) {
				try {
					output.write(data);
					output.flush();
					Log.e("tag", "==sendByte=>data = " + data);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

			}
		}
	}

	public void sendBytes(byte[] datas) {
		Log.e("tag", "==>send byte");
		if (socket != null && socket.isConnected()) {
			if (output != null) {
				try {
					output.write(datas);
					output.flush();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				Log.e("tag", "==sendBytes=>sendOk");
			}
		}
	}

	public boolean isConnected() {
		if (socket != null && socket.isConnected()) {
			return true;
		}
		return false;
	}

	private int count = 5;
	private Runnable runnable = new Runnable() {

		@Override
		public void run() {
			// TODO Auto-generated method stub
			Log.e("tag", "===>coutn = " + count);
			if (count == 0) {
				mHandler.obtainMessage(Util.WIFI_STATE, Util.STATE_NONE, -1)
						.sendToTarget();
			} else {
				count--;
				mHandler.postDelayed(runnable, 1000);
			}
		}
	};

}
